var KeyHandler = {
    blocked: false,
    popupBlock: false,
    configBlock: false,
    /**
     * Устанавливает текущий обработчик нажатий
     * @param {type} handler
     */
    setKeyHandler: function(handler) {
        this.currentHandler = handler;
    },
    /**
     * Активирует блокировку нажатий клавиш. Любые клавиши не обрабатываются
     */
    enableBlock: function(){
        KeyHandler.blocked = true;
    },
    /**
     * Отключает режим блокировки клавиш
     */
    disableBlock: function(){
        KeyHandler.blocked = false;
    },
    /**
     * Включает обработку клавиш всплывающего сообщения
     */
    enablePopupBlock: function(){
        KeyHandler.popupBlock = true;
    },
    /**
     * Отключает обработку клавиш всплывающего сообщения
     */
    disablePopupBlock: function(){
        KeyHandler.popupBlock = false;
    },
    enableConfigBlock: function(){
        KeyHandler.configBlock = true;
    },
    disableConfigBlock: function(){
        KeyHandler.configBlock = false;
    },
    /**
     * Главный обработчик клвиш
     */
    handleKey: function() {
        var code = event.keyCode;
        if(!KeyHandler.blocked){ // Заблокировано. Не обрабатываю нажатия
            if(!KeyHandler.popupBlock){ // Всплывающего окна нет. Идём далее
                if(!KeyHandler.configBlock){ // Не показано окно настроек. Идём далее
                    if (Menu.menuShown){
                        Menu.keyHandler(code);
                    }else{
                        Player.handleKey(code);
                    }
                }else{ // Показано окно настроек. Обрабатываю
                    Configs.handleKey(code);
                }
            }else{ // Показано всплывающее окно. Обрабатываю нажатия
                Popup.handleKey(code);
            }
        }
    }
};