var Menu = {
    navigationLevel: 0,
    zeroLevelActiveId: 'iconTv',
    tv: {
        1: {
            elements: [
                {id: 'category0', title: "Любимые"}, {id: 'category1', title: 'Новости'}, {id: 'category2', title: 'Общие'},
                {id: 'category3', title: "Наука"}, {id: 'category4', title: 'Кино'}, {id: 'category5', title: 'Спорт'},
                {id: 'category6', title: "Детям"}, {id: 'category7', title: 'Музыка'}, {id: 'category8', title: 'Взрослым'},
                {id: 'category9', title: "HD"}, {id: 'category10', title: 'Радио'}
            ],
            active: 0, showCount: 8, firstShow: 0, lastShow: 7, count: 11, styleClass: 'channelCategoryActive', type: 'static'
        },
        2: {elements: {}, active: 0, showCount: 5, firstShow: 0, lastShow: 4, count: 0, styleClass: 'channelActive', type: 'dynamic'},
        3: {elements: [], active: 0, showCount: 7, firstShow: 0, lastShow: 7, count: 0, styleClass: 'menuTvProgramActive', type: 'dynamic'}
    },
    hideMenuInterval: 0,
    menuShown: true,
    infoSecondLevelActive: '',
    infoElements:{1: ["messages","news"], 2: [], 3: []},
    infoStructure:{level: 1,
        1: {active: 0, child: 'messagesChild', hasNextLevel: true, action: 'none'},
        2: {active: 0, child: '', hasNextLevel: true, action: 'none'},
        3: {active: 0, child: '', hasNextLevel: false, action: 'showMessage'}
    },
    infoShowParams:{showCount: 5, firstShow: 0, lastShow: 4},
    lockElements:{1: ["lock", "remindPass", "subscription", "calculation"], 2: [], 3: []},
    lockStructure: {level: 1,
        1: {active: 0, child: '', hasNextLevel: false, action: 'lock'},
        2: {active: 0, child: '', hasNextLevel: true, action: 'none'},
        3: {active: 0, child: '', hasNextLevel: false, action: 'showMessage'}    
    },
    lockShowParams:{showCount: 5, firstShow: 0, lastShow: 4},
    gearsElements: {1: ["configs"], 2: [], 3:[]},
    gearsStructure: {level: 1,
        1: {active: 0, child: '', hasNextLevel: false, action: 'configs'},
        2: {active: 0, child: '', hasNextLevel: false, action: 'none'},
        3: {active: 0, child: '', hasNextLevel: false, action: 'none'}
    },
    gearsShowParams:{showCount: 5, firstShow: 0, lastShow: 4},
    // Menu common methods
    /**
     * Показывает меню
     */
    showMenu: function() {
        if (!Menu.menuShown) {
            Core.removeClass(Core.getById('menu'), 'unshown');
            Menu.menuShown = true;
        }
    },
    /**
     * Показывает меню и скрывает его через 7 секунд
     */
    showAndHideMenu: function() {
        window.clearTimeout(Menu.hideMenuInterval);
        Menu.showMenu();
        Menu.hideMenuInterval = window.setTimeout(Menu.hideMenu, 7000);
    },
    /**
     * Скрывает меню
     */
    hideMenu: function() {
        window.clearTimeout(Menu.hideMenuInterval);
        if (Menu.menuShown) {
            Core.addClass(Core.getById('menu'), 'unshown');
            Menu.menuShown = false;
        }
    },
    /**
     * Основной обработчик нажатия клавиш в меню
     * @param {type} code кейкод клавиши
     * @returns {undefined}
     */
    keyHandler: function(code) {
        this.showAndHideMenu();

        if (this.navigationLevel != 0) {
            switch (this.zeroLevelActiveId) {
                case 'iconTv':
                    this.navigateChannels(code);
                    break;
                case 'iconInfo':
                    this.navigateInfo(code);
                    break;
                case 'iconLock':
                    this.navigateLock(code);
                    break;
                case 'iconGears':
                    Menu.navigateGears(code);
                    break;
            }
        } else {
            switch (code) {
                case tvKey.KEY_UP:
                    this.zeroLevelKeyPress('prev');
                    break;
                case tvKey.KEY_DOWN:
                    this.zeroLevelKeyPress('next');
                    break;
                case tvKey.KEY_RIGHT:
                    switch (Menu.zeroLevelActiveId) {
                        case 'iconTv':
                            Menu.navigationLevel = 1;
                            Core.addClass(Core.getById("category"+Menu.tv[Menu.navigationLevel].active), 'channelCategoryActive');
                            Core.addClass(Core.getById("menu2ColumnLock"), 'unshown');
                            Core.addClass(Core.getById("menu2ColumnInfo"), 'unshown');
                            Core.addClass(Core.getById("menu3ColumnLock"), 'unshown');
                            Core.addClass(Core.getById("menu3ColumnInfo"), 'unshown');
                            Core.removeClass(Core.getById("menu2ColumnTv"), 'unshown');
                            Core.removeClass(Core.getById("menu3ColumnTv"), 'unshown');
                            
                            Menu.appendChannelsSecondLevel(Menu.tv[Menu.navigationLevel].active);
                            Program.updateProgramInfo();
                            break;
                        case 'iconInfo':
                            Menu.navigationLevel = 1;
                            Core.addClass(Core.getById("menu2ColumnLock"), 'unshown');
                            Core.addClass(Core.getById("menu2ColumnTv"), 'unshown');
                            Core.addClass(Core.getById("menu3ColumnLock"), 'unshown');
                            Core.addClass(Core.getById("menu3ColumnTv"), 'unshown');
                            Core.removeClass(Core.getById("menu2ColumnInfo"), 'unshown');
                            Core.removeClass(Core.getById("menu3ColumnInfo"), 'unshown');

                            Menu.infoStructure.level = 1;
                            Menu.infoStructure[1].active = 0;
                            Core.addClass(Core.getById(Menu.infoElements[1][0]), 'menuElementActive');
                            Menu.showMessagesMenu();
                            break;
                        case 'iconLock':
                            Menu.navigationLevel = 1;
                            Core.addClass(Core.getById("menu2ColumnInfo"), 'unshown');
                            Core.addClass(Core.getById("menu2ColumnTv"), 'unshown');
                            Core.addClass(Core.getById("menu3ColumnInfo"), 'unshown');
                            Core.addClass(Core.getById("menu3ColumnTv"), 'unshown');
                            Core.removeClass(Core.getById("menu2ColumnLock"), 'unshown');
                            Core.removeClass(Core.getById("menu3ColumnLock"), 'unshown');

                            Menu.lockStructure.level = 1;
                            Menu.lockStructure[1].active = 0;
                            Core.addClass(Core.getById(Menu.lockElements[1][0]), 'menuElementActive');
                            break;
                        case 'iconGears':
                            Menu.navigationLevel = 1;
                            
                            Menu.gearsStructure.level = 1;
                            Menu.gearsStructure[1].active = 0;
                            Core.addClass(Core.getById(Menu.gearsElements[1][0]), 'menuElementActive');
                            break;
                    }
                    break;
                case tvKey.KEY_RETURN:
                    widgetAPI.blockNavigation(event);
                    Menu.hideMenu();
                    break;
                default:
                    Player.handleKey(code);
                    break;
            }
        }
    },
    /**
     * Обработчик нажатия кнопок на 0 уровне
     * @param {String} direction направление вверх или вниз
     */
    zeroLevelKeyPress: function(direction) {
        Menu.zeroLevelActiveId = Core.getByClass('.menuRootElementActive').getAttribute('data-' + direction);
        Core.removeClass(Core.getByClass('.menuRootElementActive'), 'menuRootElementActive');
        Core.addClass(Core.getById(Menu.zeroLevelActiveId), 'menuRootElementActive');
        switch (Menu.zeroLevelActiveId) {
            case 'iconTv':
                Core.getById('iconTVimg').setAttribute('src', 'images/common/icon_tv_active.png');
                Core.getById('iconInfoimg').setAttribute('src', 'images/common/icon_info.png');
                Core.getById('iconLockimg').setAttribute('src', 'images/common/icon_lock.png');
                Core.getById('iconGearsimg').setAttribute('src', 'images/common/icon_gears.png');

                Core.removeClass(Core.getById('menu1ColumnTv'), 'unshown');
                Core.addClass(Core.getById("menu1ColumnLock"), 'unshown');
                Core.addClass(Core.getById("menu1ColumnInfo"), 'unshown');
                Core.addClass(Core.getById("menu1ColumnGears"), 'unshown');
                break;
            case 'iconInfo':
                Core.getById('iconTVimg').setAttribute('src', 'images/common/icon_tv.png');
                Core.getById('iconInfoimg').setAttribute('src', 'images/common/icon_info_active.png');
                Core.getById('iconLockimg').setAttribute('src', 'images/common/icon_lock.png');
                Core.getById('iconGearsimg').setAttribute('src', 'images/common/icon_gears.png');

                Core.removeClass(Core.getById('menu1ColumnInfo'), 'unshown');
                Core.addClass(Core.getById("menu1ColumnLock"), 'unshown');
                Core.addClass(Core.getById("menu1ColumnTv"), 'unshown');
                Core.addClass(Core.getById("menu1ColumnGears"), 'unshown');
                break;
            case 'iconLock':
                Core.getById('iconTVimg').setAttribute('src', 'images/common/icon_tv.png');
                Core.getById('iconInfoimg').setAttribute('src', 'images/common/icon_info.png');
                Core.getById('iconLockimg').setAttribute('src', 'images/common/icon_lock_active.png');
                Core.getById('iconGearsimg').setAttribute('src', 'images/common/icon_gears.png');

                Core.removeClass(Core.getById('menu1ColumnLock'), 'unshown');
                Core.addClass(Core.getById("menu1ColumnInfo"), 'unshown');
                Core.addClass(Core.getById("menu1ColumnTv"), 'unshown');
                Core.addClass(Core.getById("menu1ColumnGears"), 'unshown');
                break;
            case 'iconGears':
                Core.getById('iconTVimg').setAttribute('src', 'images/common/icon_tv.png');
                Core.getById('iconInfoimg').setAttribute('src', 'images/common/icon_info.png');
                Core.getById('iconLockimg').setAttribute('src', 'images/common/icon_lock.png');
                Core.getById('iconGearsimg').setAttribute('src', 'images/common/icon_gears_active.png');
                
                Core.removeClass(Core.getById('menu1ColumnGears'), 'unshown');
                Core.addClass(Core.getById("menu1ColumnInfo"), 'unshown');
                Core.addClass(Core.getById("menu1ColumnTv"), 'unshown');
                Core.addClass(Core.getById("menu1ColumnLock"), 'unshown');
                break;
        }
    },
    // Menu commen methods end
    
    // Gears block
    gearsUpDownNavigation: function(direction){
        Core.removeClass(Core.getById(Menu.getActiveGearsElement()), 'menuElementActive');
        if(Menu.gearsStructure[Menu.gearsStructure.level].hasNextLevel){
            Core.addClass(Core.getById(Menu.gearsStructure[Menu.gearsStructure.level].child), 'unshown');
        }
        if(direction == 'up'){
            if(Menu.gearsStructure[Menu.gearsStructure.level].active == 0){
                Menu.gearsStructure[Menu.gearsStructure.level].active = Menu.gearsElements[Menu.gearsStructure.level].length - 1;
                Menu.gearsShowParams.lastShow = Menu.gearsStructure[Menu.gearsStructure.level].active;
                Menu.gearsShowParams.firstShow = Menu.gearsShowParams.lastShow - Menu.gearsShowParams.showCount + 1;
            }else{
                Menu.gearsStructure[Menu.gearsStructure.level].active -= 1;
                if(Menu.gearsShowParams.firstShow > Menu.gearsStructure[Menu.gearsStructure.level].active){
                    Menu.gearsShowParams.firstShow -= 1;
                    Menu.gearsShowParams.lastShow -= 1;
                }
            }
        }else{
            if(Menu.gearsStructure[Menu.gearsStructure.level].active == Menu.gearsElements[Menu.gearsStructure.level].length - 1){
                Menu.gearsStructure[Menu.gearsStructure.level].active = 0;
                Menu.gearsShowParams.firstShow = 0;
                Menu.gearsShowParams.lastShow = Menu.gearsShowParams.showCount - 1;
            }else{
                Menu.gearsStructure[Menu.gearsStructure.level].active += 1;
                if(Menu.gearsShowParams.lastShow < Menu.gearsStructure[Menu.gearsStructure.level].active){
                    Menu.gearsShowParams.firstShow += 1;
                    Menu.gearsShowParams.lastShow += 1;
                }
            }
        }
        if(Menu.gearsElements[Menu.gearsStructure.level].length > Menu.gearsShowParams.showCount){
            for(var i = 0; i < Menu.gearsElements[Menu.gearsStructure.level].length; i++){
                if(i >= Menu.gearsShowParams.firstShow && i <= Menu.gearsShowParams.lastShow){
                    Core.removeClass(Core.getById(Menu.gearsElements[Menu.gearsStructure.level][i]), 'unshown');
                }else{
                    Core.addClass(Core.getById(Menu.gearsElements[Menu.gearsStructure.level][i]), 'unshown');
                }
            }
        }
        Core.addClass(Core.getById(Menu.getActiveGearsElement()), 'menuElementActive');
    },
    getActiveGearsElement: function(){
        return Menu.gearsElements[Menu.gearsStructure.level][Menu.gearsStructure[Menu.gearsStructure.level].active];
    },
    resetGearsShowParams: function(){
        Menu.gearsShowParams = {showCount: 5, firstShow: 0, lastShow: 4};
    },
    navigateGears: function(code) {
        switch (code) {
            case tvKey.KEY_LEFT:
                switch(Menu.gearsStructure.level){
                    case 1:
                        Menu.resetGearsShowParams();
                        Core.removeClass(Core.getById(Menu.getActiveGearsElement()), 'menuElementActive');
                        Menu.navigationLevel = 0;
                        break;
                    case 2: break;
                    case 3: break;
                }
                break;
            case tvKey.KEY_RIGHT:
//                switch(Menu.gearsStructure.level){
//                    case 1: break;
//                    case 2: break;
//                    case 3: break;
//                }
                break;
            case tvKey.KEY_UP:
                Menu.gearsUpDownNavigation("up");
                break;
            case tvKey.KEY_DOWN:
                Menu.gearsUpDownNavigation("down");
                break;
            case tvKey.KEY_ENTER:
                switch(Menu.gearsStructure[Menu.gearsStructure.level].action){
                    case 'none': break; // ничего не надо делать
                    case 'configs': 
                        Configs.show();
                        break;
                }
                break;
            case tvKey.KEY_RETURN:
                widgetAPI.blockNavigation(event);
                Menu.hideMenu();
                break;
            default:
                Player.handleKey(code);
                break;
        }
    },
    // end gears block
     
    // Info block
    /**
     * Вспомогательный метод, который сбрасывает параметры Menu.infoShowParams в дефолтные
     */
    resetInfoShowParams: function(){
        Menu.infoShowParams = {showCount: 5, firstShow: 0, lastShow: 4};
    },
    /**
     * Показывает подменю сообщений. (пункты прочитанные и непрочитанные)
     */
    showMessagesMenu: function(){
        Menu.resetInfoShowParams();
        Menu.infoElements[2] = ["messagesUnreaded", "messagesReaded"];
        Menu.infoStructure[1].child = 'messagesChild';
        Menu.infoStructure[2].child = 'messagesList';
        Menu.infoStructure[2].active = 0;
        Menu.infoStructure[2].action = "none";
        Menu.infoStructure[2].hasNextLevel = true;
        Core.removeClass(Core.getById('messagesChild'), 'unshown');
    },
    /**
     * Показывает список сообщений.
     * @param {type} type (id выделенного элемента на предыдущем уровне) прочитанные или непрочитанные сообщения показывать
     */
    showMessagesList: function(type){
        Menu.resetInfoShowParams();
        var tmp = '', messages;
        Menu.infoElements[3] = [];
        Messages.loadMessages();
        if(type == "messagesUnreaded"){
            messages = Messages.getUnreadedMessages();
        }else{
            messages = Messages.getReadedMessages();
        }
        if(messages.length != 0){
            for(var i = 0; i < messages.length; i++){
                tmp += '<div id="message'+messages[i].id+'" data-id="'+messages[i].id+'" class="menuElement '+(i>Menu.infoShowParams.lastShow?"unshown":"")+'">'+messages[i].title+'</div>';
                Menu.infoElements[3].push('message'+messages[i].id);
            }
        }else{
            tmp = '<div id="messageEmpty" data-id="empty" class="menuElement">Сообщения отсутствуют.</div>';
            Menu.infoElements[3].push('messageEmpty');
        }
        Menu.infoStructure[3].active = 0;
        Menu.infoStructure[3].action = 'showMessage';
        Core.innerHTML(Core.getById("messagesList"), tmp);
        Core.removeClass(Core.getById('messagesList'), 'unshown');
    },
    /**
     * Показывает список новостей
     */
    showNewsMenu: function(){
        Menu.resetInfoShowParams();
        var tmp = '';
        Menu.infoElements[2] = [];
        News.load();
        for(var i = 0; i < News.list.length; i++){
            tmp += '<div id="news'+News.list[i].id+'" class="menuElement" data-nid="'+News.list[i].id+'">'+News.list[i].title+'</div>';
            Menu.infoElements[2].push("news"+News.list[i].id);
        }
        
        Menu.infoStructure[1].child = "newsChild";
        Menu.infoStructure[2].active = 0;
        Menu.infoStructure[2].action = 'showNews';
        Menu.infoStructure[2].hasNextLevel = false;
        Core.innerHTML(Core.getById("newsChild"), tmp);
        Core.removeClass(Core.getById('newsChild'), 'unshown');
    },
    /**
     * Возвращает текущий активный элемент в пункте info.
     * @returns {unresolved}
     */
    getActiveInfoElement: function(){
        return Menu.infoElements[Menu.infoStructure.level][Menu.infoStructure[Menu.infoStructure.level].active];
    },
    /**
     * Навигация вверх-вниз по пунктам
     * @param {type} direction направление - вверх или вниз
     */
    infoUpDownNavigation: function(direction){
        Core.removeClass(Core.getById(Menu.getActiveInfoElement()), 'menuElementActive');
        if(Menu.infoStructure[Menu.infoStructure.level].hasNextLevel){
            Core.addClass(Core.getById(Menu.infoStructure[Menu.infoStructure.level].child), 'unshown');
        }
        if(direction == 'up'){
            if(Menu.infoStructure[Menu.infoStructure.level].active == 0){
                Menu.infoStructure[Menu.infoStructure.level].active = Menu.infoElements[Menu.infoStructure.level].length - 1;
                Menu.infoShowParams.lastShow = Menu.infoStructure[Menu.infoStructure.level].active;
                Menu.infoShowParams.firstShow = Menu.infoShowParams.lastShow - Menu.infoShowParams.showCount + 1;
            }else{
                Menu.infoStructure[Menu.infoStructure.level].active -= 1;
                if(Menu.infoShowParams.firstShow > Menu.infoStructure[Menu.infoStructure.level].active){
                    Menu.infoShowParams.firstShow -= 1;
                    Menu.infoShowParams.lastShow -= 1;
                }
            }
        }else{
            if(Menu.infoStructure[Menu.infoStructure.level].active == Menu.infoElements[Menu.infoStructure.level].length - 1){
                Menu.infoStructure[Menu.infoStructure.level].active = 0;
                Menu.infoShowParams.firstShow = 0;
                Menu.infoShowParams.lastShow = Menu.infoShowParams.showCount - 1;
            }else{
                Menu.infoStructure[Menu.infoStructure.level].active += 1;
                if(Menu.infoShowParams.lastShow < Menu.infoStructure[Menu.infoStructure.level].active){
                    Menu.infoShowParams.firstShow += 1;
                    Menu.infoShowParams.lastShow += 1;
                }
            }
        }
        if(Menu.infoElements[Menu.infoStructure.level].length > Menu.infoShowParams.showCount){
            for(var i = 0; i < Menu.infoElements[Menu.infoStructure.level].length; i++){
                if(i >= Menu.infoShowParams.firstShow && i <= Menu.infoShowParams.lastShow){
                    Core.removeClass(Core.getById(Menu.infoElements[Menu.infoStructure.level][i]), 'unshown');
                }else{
                    Core.addClass(Core.getById(Menu.infoElements[Menu.infoStructure.level][i]), 'unshown');
                }
            }
        }
        Core.addClass(Core.getById(Menu.getActiveInfoElement()), 'menuElementActive');
        switch(Menu.infoStructure.level){
            case 1:
                switch(Menu.getActiveInfoElement()){
                    case 'messages':
                        Menu.showMessagesMenu();
                        break;
                    case 'news':
                        Menu.showNewsMenu();
                        break;
                }
                break;
            case 2:
                if(Menu.infoStructure[Menu.infoStructure.level].hasNextLevel){
                    Menu.showMessagesList(Menu.getActiveInfoElement());
                }
                break;
            case 3: break;
        }
    },
    /**
     * Навигация по пунктам в инфо
     * @param {type} code
     * @returns {undefined}
     */
    navigateInfo: function(code) {
        switch (code) {
            case tvKey.KEY_LEFT:
                switch(Menu.infoStructure.level){
                    case 1:
                        Menu.resetInfoShowParams();
                        Core.removeClass(Core.getById(Menu.getActiveInfoElement()), 'menuElementActive');
                        Core.addClass(Core.getById(Menu.infoStructure[1].child), 'unshown');
                        Menu.navigationLevel = 0;
                        break;
                    case 2:
                        Menu.resetInfoShowParams();
                        Core.removeClass(Core.getById(Menu.getActiveInfoElement()), 'menuElementActive');
                        if(Menu.infoStructure[2].hasNextLevel){
                            Core.addClass(Core.getById(Menu.infoStructure[2].child), 'unshown');
                        }
                        Menu.infoStructure.level = 1;
                        break;
                    case 3: 
                        Menu.resetInfoShowParams();
                        Core.removeClass(Core.getById(Menu.getActiveInfoElement()), 'menuElementActive');
                        Menu.infoStructure.level = 2;
                        break;
                }
                break;
            case tvKey.KEY_RIGHT:
                switch(Menu.infoStructure.level){
                    case 1:
                        Menu.infoStructure.level = 2;
                        Core.addClass(Core.getById(Menu.getActiveInfoElement()), 'menuElementActive');
                        if(Menu.infoStructure[Menu.infoStructure.level].hasNextLevel){
                            Menu.showMessagesList(Menu.getActiveInfoElement());
                        }
                        break;
                    case 2:
                        if(Menu.infoStructure[Menu.infoStructure.level].hasNextLevel){
                            Menu.infoStructure.level = 3;
                            Core.addClass(Core.getById(Menu.getActiveInfoElement()), 'menuElementActive');
                        }
                        break;
                    case 3: break;
                }
                break;
            case tvKey.KEY_UP:
                Menu.infoUpDownNavigation("up");
                break;
            case tvKey.KEY_DOWN:
                Menu.infoUpDownNavigation("down");
                break;
            case tvKey.KEY_ENTER:
                switch(Menu.infoStructure[Menu.infoStructure.level].action){
                    case 'none': break; // ничего не надо делать
                    case 'showNews': 
                        var news = News.getById(Core.getById(Menu.getActiveInfoElement()).getAttribute('data-nid'));
                        Popup.createConfirmPopup(news.title, news.text, [{type: 'submit', action: function(){Popup.hide()},name: "Ок"}, {type: 'close', action: function(){Popup.hide()},name: "Закрыть"}]);
                        break;
                    case 'showMessage': 
                        var messageId = Core.getById(Menu.getActiveInfoElement()).getAttribute('data-id');
                        if(messageId != 'empty'){
                            Messages.showMessage(messageId);
                        }
                        break
                }
                break;
            case tvKey.KEY_RETURN:
                widgetAPI.blockNavigation(event);
                Menu.hideMenu();
                break;
            default:
                Player.handleKey(code);
                break;
        }
    },
    // Info block end
    
    // Channels block
    moveChannel: function(direction){
        var elem;
        if(direction == "up"){
            elem = $(".channelActive").prev();
            $(".channelActive").detach().insertBefore(elem);
            Menu.tvKeyUp(2);
        }else{
            elem = $(".channelActive").next();
            $(".channelActive").detach().insertAfter(elem);
            Menu.tvKeyDown(2);
        }
    },
    /**
     * Добавляет 3 уровень телеканалов (Список каналов)
     * @param {type} pid id предыдущего уровня
     */
    appendChannelsSecondLevel: function(pid) {
        if(Menu.tv[2].elements[pid].length > 0){
            // вспомогательная переменная
            var q = Menu.tv[2];
            q.active = 0;
            q.firstShow = 0;
            q.count = q.elements[pid].length;
            if (q.count >= q.showCount) {
                q.lastShow = q.showCount - 1;
            } else {
                q.lastShow = q.count - 1;
            }

            var style, i, tmp = '<div class="menuInfoPanel"><img src="images/common/paging-arrow-up.png"/><div class="menuInfoPanelStatus"><span id="menu2ColumnTvCurrent" class="menuInfoPanelStatusCurrent">1</span> / <span class="menuInfoPanelStatusAll">' + q.count + '</span></div></div><div id="menu2ColumnTvNavigationElements">';
            for (i = 0; i < q.count; i++) {
                if (i >= q.firstShow && i <= q.lastShow) {
                    style = "";
                } else {
                    style = "unshown";
                }
                if(!q.elements[pid][i].available){
                    style += " unavailableChannel";
                }
                tmp += '<div class="channel ' + style + '" id="channel' + q.elements[pid][i].id + '" data-id="' + q.elements[pid][i].id + '">'
                        + '<div class="channelName">' + q.elements[pid][i].name + '</div>'
                        + (q.elements[pid][i].age_limit != null ? '<img class="channelAgeLimit" src="images/ageLimits/' + q.elements[pid][i].age_limit + '.png"/>' : "")
                        + '<img class="channelLock ' +(q.elements[pid][i].age_limit != null && Channel.porn_locked?"":"unshown")+ '" src="images/common/lock.png"/>'
                        + '<div class="channelLogo"><img id="channel' + q.elements[pid][i].id + 'Logo" src="http://stb.lanta-net.ru/stb-client-pre/static/images/1920x1080/logo/' + q.elements[pid][i].id + '.jpg"></div>'
                        + '<div class="channelTvProgram">'
                        + '<div class="channelTvProgramTitle"></div>'
                        + '<div class="channelTvProgramTime"></div>' // до 14:50
                        + '<div class="channelTvProgramProgress unshown">'
                        + '<div style="width:0%;" class="channelTvProgramProgressLost"></div>'
                        + '</div>'
                        + '</div>'
                        + '</div>';
            }
            tmp += '</div><div class="menuInfoPanel"><img src="images/common/paging-arrow-down.png"></div>';
            Core.innerHTML(Core.getById("menu2ColumnTv"), tmp);
            Menu.tv[2] = q;
        }else{
            Core.innerHTML(Core.getById("menu2ColumnTv"), '');
        }
    },
    reinitFavouriteChannelsSecondLevel: function(pid, activeId){
        // вспомогательная переменная
            var q = Menu.tv[2];
            q.count = q.elements[pid].length;
            for (i = 0; i < q.count; i++) {
                if(q.elements[pid][i].id==activeId){
                    q.active = i;
                    break;
                }
            }
            if(q.lastShow >= q.count){
                q.firstShow -= 1;
                q.lastShow -= 1;
            }

            var style, i, tmp = '<div class="menuInfoPanel"><img src="images/common/paging-arrow-up.png"/><div class="menuInfoPanelStatus"><span id="menu2ColumnTvCurrent" class="menuInfoPanelStatusCurrent">1</span> / <span class="menuInfoPanelStatusAll">' + q.count + '</span></div></div><div id="menu2ColumnTvNavigationElements">';
            for (i = 0; i < q.count; i++) {
                if (i >= q.firstShow && i <= q.lastShow) {
                    style = "";
                } else {
                    style = "unshown";
                }
                if(!q.elements[pid][i].available){
                    style += " unavailableChannel";
                }
                tmp += '<div class="channel ' + style + " " + (q.elements[pid][i].id==activeId?"channelActive":"") + '" id="channel' + q.elements[pid][i].id + '" data-id="' + q.elements[pid][i].id + '">'
                        + '<div class="channelName">' + q.elements[pid][i].name + '</div>'
                        + (q.elements[pid][i].age_limit != null ? '<img class="channelAgeLimit" src="images/ageLimits/' + q.elements[pid][i].age_limit + '.png"/>' : "")
                        + '<img class="channelLock ' +(q.elements[pid][i].age_limit != null && Channel.porn_locked?"":"unshown")+ '" src="images/common/lock.png"/>'
                        + '<div class="channelLogo"><img id="channel' + q.elements[pid][i].id + 'Logo" src="http://stb.lanta-net.ru/stb-client-pre/static/images/1920x1080/logo/' + q.elements[pid][i].id + '.jpg"></div>'
                        + '<div class="channelTvProgram">'
                        + '<div class="channelTvProgramTitle"></div>'
                        + '<div class="channelTvProgramTime"></div>' // до 14:50
                        + '<div class="channelTvProgramProgress unshown">'
                        + '<div style="width:0%;" class="channelTvProgramProgressLost"></div>'
                        + '</div>'
                        + '</div>'
                        + '</div>';
            }
            tmp += '</div><div class="menuInfoPanel"><img src="images/common/paging-arrow-down.png"></div>';
            Core.innerHTML(Core.getById("menu2ColumnTv"), tmp);
            Menu.tv[2] = q;
            Program.updateProgramInfo();
    },
    /**
     * Добавляет последний уровень телеканалов (Последний с телепрограммой)
     * @param {type} cid id телеканала
     * @param {type} mid id пункта меню
     */
    appendChannelsThirdLevel: function(cid, mid) {
        // вспомогательная переменная. Для упрощения
        var q = Menu.tv[3];
        q.active = 0;
        q.firstShow = 0;

        var fav, progs, tmp = '', arrows = '', arrowsCount = 0;
        if (Channel.isFavourite(cid)) {
            fav = '<div data-action="favourite" data-ftype="remove" class="menuTvProgramFavourite"><img src="images/favourite/removeFromFavourite.png" align="top"> Из любимых</div>';
        } else {
            fav = '<div data-action="favourite" data-ftype="add" class="menuTvProgramFavourite"><img src="images/favourite/addToFavourite.png" align="top"> В любимые</div>';
        }
        if (mid == 0) {
            if (Channel.getFavouritePosition(cid) == 1) {
                arrows = '<div data-action="down" class="menuTvProgramFavourite"><img src="images/favourite/arrow_down.png" align="top"> Вниз</div>';
                arrowsCount = 1;
            } else {
                if (Channel.getFavouritePosition(cid) == Menu.tv[2].count) {
                    arrows = '<div data-action="up" class="menuTvProgramMove"><img src="images/favourite/arrow_up.png" align="top"> Вверх</div>';
                    arrowsCount = 1;
                } else {
                    arrows = '<div data-action="up" class="menuTvProgramMove"><img src="images/favourite/arrow_up.png" align="top"> Вверх</div><div data-action="down" class="menuTvProgramFavourite"><img src="images/favourite/arrow_down.png" align="top"> Вниз</div>';
                    arrowsCount = 2;
                }
            }
        }
        
        progs = Program.getAllByChannel(cid);
        if (progs != undefined && Time.rightTime) {
            q.showCount = 7;
            q.count = progs.length + 1;
            if (q.count >= q.showCount) {
                q.lastShow = q.showCount - 1;
            } else {
                q.lastShow = q.count - 1;
            }

            var tempTo = q.lastShow;
            if (mid == 0) {
                tempTo = tempTo - arrowsCount;
            }

            tmp += '<div class="menuInfoPanel"><img src="images/common/paging-arrow-up.png"><div class="menuInfoPanelStatus"><span id="menu3ColumnTvCurrent" class="menuInfoPanelStatusCurrent">1</span> / <span class="menuInfoPanelStatusAll">' + q.count + '</span></div></div>';
            tmp += '<div id="menu3ColumnTvNavigationElements">' + fav + arrows;
            var style;
            for (var i = 0; i < progs.length; i++) {
                if (i >= q.firstShow && i < tempTo) {
                    style = "";
                } else {
                    style = "unshown";
                }
                tmp += '<div data-action="none" class="menuTvProgram ' + style + '">'
                        + (progs[i].ageLimit != null ? '<img class="menuTvProgramAgeLimit" src="images/ageLimits/' + progs[i].ageLimit + '.png"/>' : "")
                        + '<div class="menuTvProgramText">' + progs[i].timeStarting + ' ' + progs[i].name + '</div>'
                        + '</div>';
            }
            tmp += '</div><div class="menuInfoPanel"><img src="images/common/paging-arrow-down.png"></div>';
        } else {
            if (mid != 0) {
                q.showCount = 2;
                q.count = 2;
                q.lastShow = 1;
            } else {
                q.showCount = 2 + arrowsCount;
                q.count = q.showCount;
                q.lastShow = q.count - 1;
            }
            tmp += '<div id="menu3ColumnTvNavigationElements">' + fav + arrows + '<div class="menuEmptyTvProgram">Телепрограмма отсутствует</div></div>';
        }
        Menu.tv[3] = q;
        Core.innerHTML(Core.getById("menu3ColumnTv"), tmp);
    },
    /**
     * Навигация для каналов
     * @param {type} code кейкод кнопки
     */
    navigateChannels: function(code) {
        switch (code) {
            case tvKey.KEY_LEFT:
                switch (Menu.navigationLevel) {
                    case 1: // К 0 уровню
                        Core.removeClass(Core.getById(Menu.zeroLevelActiveId), 'channelActive');
                        Core.removeClass(Core.getByClass('.channelCategoryActive'), 'channelCategoryActive');
                        Menu.navigationLevel = 0;
                        Core.innerHTML(Core.getById("menu2ColumnTv"), '');
                        break;
                    case 2: // К 1 уровню
                        Core.removeClass(Core.getByClass('.channelActive'), 'channelActive');
                        Menu.navigationLevel = 1;
                        Core.innerHTML(Core.getById("menu3ColumnTv"), '');
                        break;
                    case 3: // Ко 2 уровню
                        Menu.navigationLevel = 2;
                        Core.removeClass(Core.getByClass('.menuTvProgramActive'), 'menuTvProgramActive');
                        break;
                }
                break;
            case tvKey.KEY_RIGHT:
                switch (Menu.navigationLevel) {
                    case 1: // Ко 2 уровню
                        if(Menu.tv[2].elements[Menu.tv[1].active].length > 0){
                            Menu.navigationLevel = 2;
                            Core.addClass(Core.getById('channel'+Menu.tv[2].elements[Menu.tv[1].active][Menu.tv[2].active].id), 'channelActive');
                            Menu.appendChannelsThirdLevel(Menu.tv[2].elements[Menu.tv[1].active][Menu.tv[2].active].id, Menu.tv[1].active);
                        }
                        break;
                    case 2: // К 3 уровню
                        Menu.navigationLevel = 3;
                        Core.addClass(Core.getById('menu3ColumnTvNavigationElements').childNodes[Menu.tv[3].active], 'menuTvProgramActive');
                        break;
                    case 3: // Ничего
                        break;
                }
                break;
            case tvKey.KEY_UP:
                switch (Menu.navigationLevel) {
                    case 1: // Перемещение по 1 уровню
                        Menu.tvKeyUp(1);
                        Menu.appendChannelsSecondLevel(Menu.tv[1].active);
                        if(Menu.tv[2].elements[Menu.tv[1].active].length > 0){
                            Program.updateProgramInfo();
                        }
                        break;
                    case 2: // Перемещение по 2 уровню
                        Menu.tvKeyUp(2);
                        Menu.appendChannelsThirdLevel(Menu.tv[2].elements[Menu.tv[1].active][Menu.tv[2].active].id, Menu.tv[1].active);
                        break;
                    case 3: // Перемещение по 3 уровню
                        Menu.tvKeyUp(3);
                        break;
                }
                break;
            case tvKey.KEY_DOWN:
                switch (Menu.navigationLevel) {
                    case 1: // Перемещение по 1 уровню
                        Menu.tvKeyDown(1);
                        Menu.appendChannelsSecondLevel(Menu.tv[1].active);
                        if(Menu.tv[2].elements[Menu.tv[1].active].length > 0){
                            Program.updateProgramInfo();
                        }
                        break;
                    case 2: // Перемещение по 2 уровню
                        Menu.tvKeyDown(2);
                        Menu.appendChannelsThirdLevel(Menu.tv[2].elements[Menu.tv[1].active][Menu.tv[2].active].id, Menu.tv[1].active);
                        break;
                    case 3: // Перемещение по 3 уровню
                        Menu.tvKeyDown(3);
                        break;
                }
                break;
            case tvKey.KEY_ENTER:
                switch (Menu.navigationLevel) {
                    case 1: // Ничего
                        break;
                    case 2: // Запуск на просмотр
                        var channel = Menu.tv[2].elements[Menu.tv[1].active][Menu.tv[2].active];
                        if(channel.available){
                            if(channel.age_limit != null && Channel.porn_locked){
                                var callback = function(){
                                    Menu.hideMenu();
                                    Channel.setCurrentChannelId(channel.id);
                                    Player.playChannel(channel, Menu.tv[1].active);
                                }
                                Menu.showPasswordPopup(callback);
                            }else{
                                Menu.hideMenu();
                                Channel.setCurrentChannelId(channel.id);
                                Player.playChannel(channel, Menu.tv[1].active);
                            }
                        }else{
                            Notifier.logError("Данный канал недоступен.")
                        }
                        break;
                    case 3: // Добавить/удалить в/из любимые/-ых
                        var channel = Menu.tv[2].elements[Menu.tv[1].active][Menu.tv[2].active];
                        var action = Core.getByClass(".menuTvProgramActive").getAttribute("data-action");
                        if(action == "favourite"){
                            Channel.actionFavouriteChannel(channel, Core.getByClass(".menuTvProgramActive").getAttribute("data-ftype"));
                        }else{
                            if(action == "up" || action == "down"){
                                Channel.moveFavouriteChannel(channel, action);
                            }
                        }
                        break;
                }
                break;
            case tvKey.KEY_RETURN:
                widgetAPI.blockNavigation(event);
                Menu.hideMenu();
                break;
            default:
                Player.handleKey(code);
                break;
        }
    },
    /**
     * Навигация по каналам вверх
     * @param {type} lev уровень
     */
    tvKeyUp: function(lev) {
        // вспомогательная переменная
        var q = Menu.tv[lev];
        var navigationElements;
        if (q.type == 'static') {
            navigationElements = Core.getById('menu' + lev + 'ColumnTvNavigationElements').getElementsByTagName('*');
        } else {
            navigationElements = Core.getById('menu' + lev + 'ColumnTvNavigationElements').childNodes;
        }
        if (q.active - 1 >= 0) {
            // снимаю выделение предыдущего активного
            Core.removeClass(navigationElements[q.active], q.styleClass);
            q.active = q.active - 1;
            // выделяю новый активный
            Core.addClass(navigationElements[q.active], q.styleClass);

            Core.innerHTML(Core.getById('menu' + lev + 'ColumnTvCurrent'), q.active + 1);

            if (q.active < q.firstShow) {
                q.firstShow = q.firstShow - 1;
                q.lastShow = q.lastShow - 1;
                for (var i = 0; i < navigationElements.length; i++) {
                    if (i >= q.firstShow && i <= q.lastShow) {
                        Core.removeClass(navigationElements[i], 'unshown');
                    } else {
                        Core.addClass(navigationElements[i], 'unshown');
                    }
                }
            }
        } else {
            // снимаю выделение предыдущего активного
            Core.removeClass(navigationElements[q.active], q.styleClass);
            q.active = q.count - 1;
            // выделяю новый активный
            Core.addClass(navigationElements[q.active], q.styleClass);

            Core.innerHTML(Core.getById('menu' + lev + 'ColumnTvCurrent'), q.active + 1);

            q.lastShow = q.active;
            q.firstShow = q.active - q.showCount + 1;
            for (var i = 0; i < navigationElements.length; i++) {
                if (i >= q.firstShow && i <= q.lastShow) {
                    Core.removeClass(navigationElements[i], 'unshown');
                } else {
                    Core.addClass(navigationElements[i], 'unshown');
                }
            }
        }
        Menu.tv[lev] = q;
    },
    /**
     * Навигация по каналам вниз
     * @param {type} lev уровень
     */
    tvKeyDown: function(lev) {
        // вспомогательная переменная
        var q = Menu.tv[lev];
        var navigationElements;
        if (q.type == 'static') {
            navigationElements = Core.getById('menu' + lev + 'ColumnTvNavigationElements').getElementsByTagName('*');
        } else {
            navigationElements = Core.getById('menu' + lev + 'ColumnTvNavigationElements').childNodes;
        }
        if (q.active + 1 < q.count) {
            // снимаю выделение предыдущего активного
            Core.removeClass(navigationElements[q.active], q.styleClass);
            q.active = q.active + 1;
            // выделяю новый активный
            Core.addClass(navigationElements[q.active], q.styleClass);

            Core.innerHTML(Core.getById('menu' + lev + 'ColumnTvCurrent'), q.active + 1);

            if (q.active > q.lastShow) {
                q.firstShow = q.firstShow + 1;
                q.lastShow = q.lastShow + 1;
                for (var i = 0; i < navigationElements.length; i++) {
                    if (i >= q.firstShow && i <= q.lastShow) {
                        Core.removeClass(navigationElements[i], 'unshown');
                    } else {
                        Core.addClass(navigationElements[i], 'unshown');
                    }
                }
            }
        } else {
            // снимаю выделение предыдущего активного
            Core.removeClass(navigationElements[q.active], q.styleClass);
            q.active = 0;
            // выделяю новый активный
            Core.addClass(navigationElements[q.active], q.styleClass);

            Core.innerHTML(Core.getById('menu' + lev + 'ColumnTvCurrent'), q.active + 1);

            q.firstShow = 0;
            q.lastShow = q.firstShow + q.showCount - 1;
            for (var i = 0; i < navigationElements.length; i++) {
                if (i >= q.firstShow && i <= q.lastShow) {
                    Core.removeClass(navigationElements[i], 'unshown');
                } else {
                    Core.addClass(navigationElements[i], 'unshown');
                }
            }
        }
        Menu.tv[lev] = q;
    },
    // Channels block end
            
    // Lock block
    renewSubscriptionMenu: function(){
        Subscriptions.load();
        var activeSubscrId = Core.getById(Menu.lockElements[2][Menu.lockStructure[2].active]).getAttribute("data-id");
        var newSubscr = Subscriptions.getById(activeSubscrId);
        
        Core.innerHTML(Core.getById("subscription"+activeSubscrId), '<div class="leftFloat">'+newSubscr.description+'</div><div class="rightFloat">'+newSubscr.cost+' р./м.</div><div class="clear">'+newSubscr.status+'</div>');
        if(Menu.showSubscriptionActionMenu("subscription"+activeSubscrId)){
            Core.addClass(Core.getById("subscriptionActionPunkt"), 'menuElementActive');
        }
    },
    /**
     * Возвращает id активного info элемента
     */
    getActiveLockElement: function(){
        return Menu.lockElements[Menu.lockStructure.level][Menu.lockStructure[Menu.lockStructure.level].active];
    },
    /**
     * Сбрасывает настройки отображения в дефолтные
     */
    resetLockShowParams: function(){
        Menu.lockShowParams = {showCount: 5, firstShow: 0, lastShow: 4};
    },
    /**
     * Показывает окно ввода пароля
     */
    showPasswordPopup: function(callback){
        Popup.createInputPopup("Снятие родительской блокировки", "Введите пароль для снятия родительской блокировки", 
            [{type: 'submit', action: function(){
                if(ProjectInfo.checkPassword(Core.getById("popupInputField").value)){
                    Core.getById("lock").setAttribute("data-action", "on");
                    Core.innerHTML(Core.getById("lock"), "Включить блокировку");
                    Channel.porn_locked = false;
                    callback();
                }
                Popup.hide();
        },name: "Ок"}, {type: 'close', action: function(){Popup.hide()},name: "Отмена"}]);
    },
    /**
     * Нафигация по категории lock
     * @param {type} code кейкод кнопки
     */
    navigateLock: function(code) {
        switch (code) {
            case tvKey.KEY_LEFT:
                switch (Menu.lockStructure.level) {
                    case 1: // К 0 уровню
                        Menu.resetLockShowParams();
                        Core.removeClass(Core.getById(Menu.getActiveLockElement()), 'menuElementActive');
                        if(Menu.lockStructure[1].hasNextLevel){
                            Core.addClass(Core.getById(Menu.lockStructure[1].child), 'unshown');
                        }
                        Menu.navigationLevel = 0;
                        break;
                    case 2: // К 1 уровню
                        Menu.resetLockShowParams();
                        Core.removeClass(Core.getById(Menu.getActiveLockElement()), 'menuElementActive');
                        if(Menu.lockStructure[2].hasNextLevel){
                            Core.addClass(Core.getById(Menu.lockStructure[2].child), 'unshown');
                        }
                        Menu.lockStructure.level = 1;
                        break;
                    case 3: // Ко 2 уровню
                        Menu.resetLockShowParams();
                        Core.removeClass(Core.getById(Menu.getActiveLockElement()), 'menuElementActive');
                        Menu.lockStructure.level = 2;
                        break;
                }
                break;
            case tvKey.KEY_RIGHT:
                switch (Menu.lockStructure.level) {
                    case 1: // Ко 2 уровню
                        if(Menu.lockStructure[1].hasNextLevel){
                            Menu.lockStructure.level = 2;
                            Core.addClass(Core.getById(Menu.getActiveLockElement()), 'menuElementActive');
                            if(Menu.lockStructure[Menu.lockStructure.level].hasNextLevel){
                                if(Menu.getActiveLockElement().startsWith("subscription")){
                                    Menu.showSubscriptionActionMenu(Menu.getActiveLockElement());
                                }else{
                                    if(Menu.getActiveLockElement() == "calculationChildBalance"){
                                        Menu.showCalculationBalanceMenu();
                                    }else{
                                        if(Menu.getActiveLockElement() == "calculationChildCurrentMonth"){
                                            Menu.showCalculationCurrentMonthMenu();
                                        }
                                    }
                                }
                            }
                        }
                        break;
                    case 2: // К 3 уровню
                        if(Menu.lockStructure[2].hasNextLevel){
                            Menu.lockStructure.level = 3;
                            Core.addClass(Core.getById(Menu.getActiveLockElement()), 'menuElementActive');
                        }
                        break;
                    case 3: // Ничего
                        break;
                }
                break;
            case tvKey.KEY_UP:
                Menu.lockUpDownNavigation("up");
                break;
            case tvKey.KEY_DOWN:
                Menu.lockUpDownNavigation("down");
                break;
            case tvKey.KEY_ENTER:
                if(Menu.lockStructure[Menu.lockStructure.level].action == 'subscriptionAction'){
                    Subscriptions.runActionTVProfile(Core.getById(Menu.lockElements[2][Menu.lockStructure[2].active]).getAttribute("data-id"));
                }else{
                    switch(Menu.getActiveLockElement()){
                        case 'lock':
                            if(Core.getById("lock").getAttribute("data-action") == "off"){
                                Menu.showPasswordPopup();
                            }else{
                                Core.getById("lock").setAttribute("data-action", "off");
                                Core.innerHTML(Core.getById("lock"), "Выключить блокировку");
                                Channel.porn_locked = true;
                            }
                            break;
                        case 'remindPass':
                            Popup.createConfirmPopup("Напомнить пароль", "Смс сообщение с паролем будет отправлено на Ваш номер.", [{type: 'submit', action: function(){ProjectInfo.remindPassword(); Popup.hide()},name: "Отправить"}, {type: 'close', action: function(){Popup.hide()},name: "Закрыть"}]);
                            break;
                    }
                }
                break;
            default:
                Player.handleKey(code);
                break;
        }
    },
    /**
     * Навигация вверх-вниз для пункта lock
     * @param {type} direction направление
     * @returns {undefined}
     */
    lockUpDownNavigation: function(direction){
        Core.removeClass(Core.getById(Menu.getActiveLockElement()), 'menuElementActive');
        if(Menu.lockStructure[Menu.lockStructure.level].hasNextLevel){
            Core.addClass(Core.getById(Menu.lockStructure[Menu.lockStructure.level].child), 'unshown');
        }
        if(direction == 'up'){
            if(Menu.lockStructure[Menu.lockStructure.level].active == 0){
                Menu.lockStructure[Menu.lockStructure.level].active = Menu.lockElements[Menu.lockStructure.level].length - 1;
                Menu.lockShowParams.lastShow = Menu.lockStructure[Menu.lockStructure.level].active;
                Menu.lockShowParams.firstShow = Menu.lockShowParams.lastShow - Menu.lockShowParams.showCount + 1;
            }else{
                Menu.lockStructure[Menu.lockStructure.level].active -= 1;
                if(Menu.lockShowParams.firstShow > Menu.lockStructure[Menu.lockStructure.level].active){
                    Menu.lockShowParams.firstShow -= 1;
                    Menu.lockShowParams.lastShow -= 1;
                }
            }
        }else{
            if(Menu.lockStructure[Menu.lockStructure.level].active == Menu.lockElements[Menu.lockStructure.level].length - 1){
                Menu.lockStructure[Menu.lockStructure.level].active = 0;
                Menu.lockShowParams.firstShow = 0;
                Menu.lockShowParams.lastShow = Menu.infoShowParams.showCount - 1;
            }else{
                Menu.lockStructure[Menu.lockStructure.level].active += 1;
                if(Menu.lockShowParams.lastShow < Menu.lockStructure[Menu.lockStructure.level].active){
                    Menu.lockShowParams.firstShow += 1;
                    Menu.lockShowParams.lastShow += 1;
                }
            }
        }
        if(Menu.lockElements[Menu.lockStructure.level].length > Menu.lockShowParams.showCount){
            for(var i = 0; i < Menu.lockElements[Menu.lockStructure.level].length; i++){
                if(i >= Menu.lockShowParams.firstShow && i <= Menu.lockShowParams.lastShow){
                    Core.removeClass(Core.getById(Menu.lockElements[Menu.lockStructure.level][i]), 'unshown');
                }else{
                    Core.addClass(Core.getById(Menu.lockElements[Menu.lockStructure.level][i]), 'unshown');
                }
            }
        }
        Core.addClass(Core.getById(Menu.getActiveLockElement()), 'menuElementActive');
        switch(Menu.lockStructure.level){
            case 1:
                switch(Menu.getActiveLockElement()){
                    case 'subscription':
                        Menu.lockStructure[1].hasNextLevel = true;
                        Menu.showSubscriptionMenu();
                        break;
                    case 'calculation':
                        Menu.lockStructure[1].hasNextLevel = true;
                        Menu.showCalculationMenu();
                        break;
                    default:
                        Menu.lockStructure[1].hasNextLevel = false;
                        break;
                }
                break;
            case 2:
                if(Menu.lockStructure[2].hasNextLevel){
                    if(Menu.getActiveLockElement().startsWith("subscription")){
                        Menu.showSubscriptionActionMenu(Menu.getActiveLockElement());
                    }else{
                        if(Menu.getActiveLockElement() == "calculationChildBalance"){
                            Menu.showCalculationBalanceMenu();
                        }else{
                            if(Menu.getActiveLockElement() == "calculationChildCurrentMonth"){
                                Menu.showCalculationCurrentMonthMenu();
                            }
                        }
                    }
                }
                break;
            case 3: break;
        }
    },
    /**
     * Показывает меню подписок
     */
    showSubscriptionMenu: function(){
        Menu.resetLockShowParams();
        var subscr = Subscriptions.load();
        var tmp = '<div id="subscriptionTarif" class="menuElement menuElementSubscription"><div>Тариф: '+subscr.static_tarif.name+'</div><div>В месяц: '+subscr.static_tarif.cost+'р.</div></div>';
        
        Menu.lockElements[2] = ["subscriptionTarif"];
        for(var i = 0; i < subscr.profiles.length; i++){
            tmp += '<div id="subscription'+subscr.profiles[i].id+'" class="menuElement menuElementSubscription '+(i>Menu.lockShowParams.lastShow-1?"unshown":"")+'" data-id='+subscr.profiles[i].id+'><div class="leftFloat">'+subscr.profiles[i].description+'</div><div class="rightFloat">'+subscr.profiles[i].cost+' р./м.</div><div class="clear">'+subscr.profiles[i].status+'</div></div>';
            Menu.lockElements[2].push('subscription'+subscr.profiles[i].id);
        }
        
        Menu.lockStructure[1].child = "subscriptionChild";
        Menu.lockStructure[1].hasNextLevel = true;
        Menu.lockStructure[2].child = "subscriptionAction";
        Menu.lockStructure[2].active = 0;
        Menu.lockStructure[2].action = 'none';
        Menu.lockStructure[2].hasNextLevel = true;
        Core.innerHTML(Core.getById("subscriptionChild"), tmp);
        Core.removeClass(Core.getById('subscriptionChild'), 'unshown');
    },
    /**
     * Показывает меню действий для подписки
     */
    showSubscriptionActionMenu: function(subscription){
        if(subscription != 'subscriptionTarif'){
            var subscr = Subscriptions.getById(Core.getById(subscription).getAttribute("data-id"));
            if(subscr.status != 'В тарифе' && subscr.status != 'Акция'){
                var tmp = '';
                
                switch(subscr.status){
                    case 'Куплен':
                        tmp = '<div id="subscriptionActionPunkt" class="menuElement">Откл. в след. месяце</div>';
                        break;
                    case 'Куплен до конца месяца':
                        tmp = '<div id="subscriptionActionPunkt" class="menuElement">Продлить подписку</div>';
                        break;
                    case 'Возможна подписка':
                        tmp = '<div id="subscriptionActionPunkt" class="menuElement">Подписаться</div>';
                        break;
                }
                
                Menu.lockElements[3] = ["subscriptionActionPunkt"];
                Menu.lockStructure[3].active = 0;
                Menu.lockStructure[2].hasNextLevel = true;
                Menu.lockStructure[3].action = 'subscriptionAction';
                Core.innerHTML(Core.getById("subscriptionAction"), tmp);
                Core.removeClass(Core.getById('subscriptionAction'), 'unshown');
                return true;
            }else{
                Menu.lockStructure[2].hasNextLevel = false;
            }
        }
        Menu.lockStructure[2].hasNextLevel = false;
        return false;
    },
    /**
     * Показывает меню расчётов
     */
    showCalculationMenu: function(){
        Menu.resetLockShowParams();
        Menu.lockElements[2] = ["calculationChildBalance", "calculationChildCurrentMonth"];
        Menu.lockStructure[1].child = 'calculationChild';
        Menu.lockStructure[1].hasNextLevel = true;
        Menu.lockStructure[2].child = 'balance';
        Menu.lockStructure[2].active = 0;
        Menu.lockStructure[2].action = "none";
        Menu.lockStructure[2].hasNextLevel = true;
        Core.removeClass(Core.getById('calculationChild'), 'unshown');
        Calculations.load();
    },
    /**
     * Показывает подменю баланс для меню расчётов
     */
    showCalculationBalanceMenu: function(){
        Menu.resetLockShowParams();
        Menu.lockStructure[2].child = 'balance';
        Menu.lockStructure[3].active = 0;
        Menu.lockStructure[3].action = 'none';
        Core.removeClass(Core.getById('balance'), 'unshown');
        
        Menu.lockElements[3] = ["balanceCurrent"];
        Core.innerHTML(Core.getById("balanceCurrent"), "Баланс: "+Calculations.balance+"р.");
        
        if(Calculations.credit){
            Core.innerHTML(Core.getById("balanceCredit"), "Кредит: "+Calculations.creditValue+"р.");
            Core.removeClass(Core.getById('balanceCredit'), 'unshown');
            Menu.lockElements[3] = ["balanceCurrent", "balanceCredit"];
        }else{
            Core.addClass(Core.getById('balanceCredit'), 'unshown');
        }
    },
    /**
     * Показывает подменю текущий месяц для меню расчётов
     */
    showCalculationCurrentMonthMenu: function(){
        Menu.resetLockShowParams();
        Menu.lockStructure[2].child = 'currentMonth';
        Menu.lockElements[3] = ["currentMonthIncome", "currentMonthOutcome"];
        Menu.lockStructure[3].active = 0;
        Menu.lockStructure[3].action = 'none';
        
        Core.innerHTML(Core.getById("currentMonthIncome"), "Начислено: "+Calculations.currentMonth.payments+"р.");
        Core.innerHTML(Core.getById("currentMonthOutcome"), "Списано: "+Calculations.currentMonth.bills+"р.");
        
        Core.removeClass(Core.getById('currentMonth'), 'unshown');
    }
    // Lock Block end
};