var Popup = {
    title: '',
    body: '',
    actionSubmit: '',
    actionCancel: '',
    element: 0,
    api: 0,
    type: 'confirm',
    ime: {},
    show: function() {
        KeyHandler.enablePopupBlock();
        Core.removeClass(Core.getById('popup'), 'unshown');
        Popup.element = jQuery('#popupCenter').jScrollPane({showArrows: true});
        Popup.api = Popup.element.data('jsp');
    },
    hide: function() {
        Core.addClass(Core.getById("popup"), 'unshown');
        KeyHandler.disablePopupBlock();
    },
    createConfirmPopup: function(title, body, buttons) {
        Popup.type = 'confirm';
        Core.addClass(Core.getById("popupInput"), 'unshown');
        Core.removeClass(Core.getById('popupBody'), 'unshown');
        Core.removeClass(Core.getById('popup'), 'inputPopup');
        Core.innerHTML(Core.getById("popupTitle"), title);
        Core.innerHTML(Core.getById("popupBody"), body);
        for (var i = 0; i < buttons.length; i++) {
            if (buttons[i].type == 'submit') {
                Core.innerHTML(Core.getById("popupButtonSubmit"), buttons[i].name);
                Popup.actionSubmit = buttons[i].action;
            } else {
                if (buttons[i].type == 'close') {
                    Core.innerHTML(Core.getById("popupButtonClose"), buttons[i].name);
                    Popup.actionCancel = buttons[i].action;
                }
            }
        }
        Popup.show();
    },
    createInputPopup: function(title, body, buttons) {
        Popup.type = 'input';
        Core.removeClass(Core.getById('popupInput'), 'unshown');
        Core.addClass(Core.getById("popupBody"), 'unshown');
        Core.addClass(Core.getById("popup"), 'inputPopup');
        Core.getById("popupInputField").value = '';
        Core.innerHTML(Core.getById("popupTitle"), title);
        for (var i = 0; i < buttons.length; i++) {
            if (buttons[i].type == 'submit') {
                Core.innerHTML(Core.getById("popupButtonSubmit"), buttons[i].name);
                Popup.actionSubmit = buttons[i].action;
            } else {
                if (buttons[i].type == 'close') {
                    Core.innerHTML(Core.getById("popupButtonClose"), buttons[i].name);
                    Popup.actionCancel = buttons[i].action;
                }
            }
        }
        Popup.show();
        
        Input.init("popupInputField");
    },
    handleKey: function(code) {
        switch (code) {
            case tvKey.KEY_LEFT:
            case tvKey.KEY_RIGHT:
                var act = Core.getByClass('.popupActive').getAttribute('data-move');
                Core.removeClass(Core.getByClass('.popupActive'), 'popupActive');
                Core.addClass(Core.getById(act), 'popupActive');
                break;
            case tvKey.KEY_UP:
                if (Popup.type == 'confirm') {
                    var percentScrolled = Popup.api.getPercentScrolledY();
                    if (percentScrolled != 0) {
                        Popup.api.scrollToPercentY(percentScrolled - 0.1);
                    }
                }
                break;
            case tvKey.KEY_DOWN:
                if (Popup.type == 'confirm') {
                    var percentScrolled = Popup.api.getPercentScrolledY();
                    if (percentScrolled != 1) {
                        Popup.api.scrollToPercentY(percentScrolled + 0.1);
                    }
                }
                break;
            case tvKey.KEY_RETURN:
                widgetAPI.blockNavigation(event);
                Popup.hide();
                break;
            case tvKey.KEY_ENTER:
                if (Core.getByClass('.popupActive').getAttribute('id') == 'popupButtonClose') {
                    Popup.actionCancel();
                } else {
                    Popup.actionSubmit();
                }
                break;
        }
    }
};

var Input = {
    object: {},
    init: function(id){
        Input.object = new IMEShell(id, Input.initParams, this);
        if(!Input.object){
            alert("object for IMEShell create failed", 3);
        }
    },
    initParams: function(imeobj){
        imeobj.setKeySetFunc('qwerty');
        imeobj.setQWERTYPos(200, 140);
        imeobj.setBlockSpace(true);

        imeobj.setKeyFunc(tvKey.KEY_RETURN, Input.onExit);
        imeobj.setKeyFunc(tvKey.KEY_EXIT, Input.onExit);
        imeobj.setEnterFunc(Input.onEnter);
        
        imeobj.setKeypadChangeFunc('12key', Input.move12KeyPosition);
        imeobj.setKeypadChangeFunc('qwerty', Input.moveqwertyPosition);

        if(_g_ime.pluginMouse_use_YN){
            imeobj._focus();
        }
        Core.getById("popupInputField").focus();
    },
    move12KeyPosition: function(){
        Input.object.setKeypadPos(670, 85, 2100);
    },
    moveqwertyPosition: function(){
        Input.object.setKeypadPos(670, 85, 1);
    },
    onExit: function(keyCode){
        Core.getById('anchor').focus();
        Popup.hide();
        return false;
    },
    onEnter: function(string){
        Core.getById('anchor').focus();
        Popup.actionSubmit();
    }
};

var ProxyInput = {
    id: '',
    object: {},
    init: function(id){
        ProxyInput.id = id;
        ProxyInput.object = new IMEShell(id, ProxyInput.initParams, this);
        if(!ProxyInput.object){
            alert("object for IMEShell create failed", 3);
        }
    },
    initParams: function(imeobj){
        imeobj.setKeySetFunc('qwerty');
        imeobj.setQWERTYPos(230, 160);
        imeobj.setBlockSpace(true);

        imeobj.setKeyFunc(tvKey.KEY_RETURN, ProxyInput.onExit);
        imeobj.setKeyFunc(tvKey.KEY_EXIT, ProxyInput.onExit);
        imeobj.setEnterFunc(ProxyInput.onEnter);
        
        imeobj.setKeypadChangeFunc('12key', ProxyInput.move12KeyPosition);
        imeobj.setKeypadChangeFunc('qwerty', ProxyInput.moveqwertyPosition);

        if(_g_ime.pluginMouse_use_YN){
            imeobj._focus();
        }
        Core.getById(ProxyInput.id).focus();
    },
    move12KeyPosition: function(){
        ProxyInput.object.setKeypadPos(750, 85, 2100);
    },
    moveqwertyPosition: function(){
        ProxyInput.object.setKeypadPos(750, 125, 1);
    },
    onExit: function(keyCode){
        Core.getById('anchor').focus();
        Core.hideElement(Core.getById("configMulticastProxyAddressInput"));
        ProjectInfo.proxyAddress = Core.getById("configMulticastProxyAddressInput").value;
        Core.getById("configMulticastProxyAddress").value = ProjectInfo.proxyAddress;
        return false;
    },
    onEnter: function(string){
        Core.getById('anchor').focus();
        Core.hideElement(Core.getById("configMulticastProxyAddressInput"));
        ProjectInfo.proxyAddress = Core.getById("configMulticastProxyAddressInput").value;
        Core.getById("configMulticastProxyAddress").value = ProjectInfo.proxyAddress;
    }
};

var Configs = {
    show: function(){
        KeyHandler.enableConfigBlock();
        if(ProjectInfo.useProxy == 'false'){
            Core.removeClass(Core.getById("connectionTypeDirectIcon"), 'myRadioButtonNotSelected');
            Core.addClass(Core.getById("connectionTypeDirectIcon"), 'myRadioButtonSelected');
            Core.removeClass(Core.getById("connectionTypeProxyIcon"), 'myRadioButtonSelected');
            Core.addClass(Core.getById("connectionTypeProxyIcon"), 'myRadioButtonNotSelected');
        }else{
            Core.removeClass(Core.getById("connectionTypeDirectIcon"), 'myRadioButtonSelected');
            Core.addClass(Core.getById("connectionTypeDirectIcon"), 'myRadioButtonNotSelected');
            Core.removeClass(Core.getById("connectionTypeProxyIcon"), 'myRadioButtonNotSelected');
            Core.addClass(Core.getById("connectionTypeProxyIcon"), 'myRadioButtonSelected');
        }
        if(ProjectInfo.proxyAddress != ''){
            Core.getById("configMulticastProxyAddress").value = ProjectInfo.proxyAddress.substring(0, (ProjectInfo.proxyAddress.indexOf("/udp/")+1));
        }
        Core.removeClass(Core.getById('config'), 'unshown');
    },
    hide: function(){
        Core.addClass(Core.getById("config"), 'unshown');
        KeyHandler.disableConfigBlock();
    },
    saveConfigs: function(){
        Configs.hide();
        Configs.checkProxyaddress();
        jQuery.ajax({
            url: Main.url+'projectinfo/saveproxyinfo?use='+ProjectInfo.useProxy+"&address="+encodeURIComponent(ProjectInfo.proxyAddress),
            dataType:"json",
            beforeSend: function(){alert("Start save configs");},
            success:function(data,textStatus) {},
            error:function(xhr, ajaxOptions, thrownError){
                alert("Error during ajax request for save configs = "+xhr.responseText);
            },
            complete:function(jqXHR, textStatus){
                alert("Configs saved. Status = "+textStatus);
            }
        });
    },
    checkProxyaddress: function(){
        if(ProjectInfo.proxyAddress != ''){
            if(!ProjectInfo.proxyAddress.startsWith("http://")){
                ProjectInfo.proxyAddress = "http://"+ProjectInfo.proxyAddress;
            }
            if(!ProjectInfo.proxyAddress.endsWith("/")){
                ProjectInfo.proxyAddress = ProjectInfo.proxyAddress+"/";
            }
            if(!ProjectInfo.proxyAddress.endsWith("udp/")){
                ProjectInfo.proxyAddress = ProjectInfo.proxyAddress+"udp/";
            }
        }
    },
    handleKey: function(code){
        switch (code) {
            case tvKey.KEY_LEFT:
            case tvKey.KEY_UP:
                var act = Core.getByClass('.configActive').getAttribute('data-prev');
                Core.removeClass(Core.getByClass('.configActive'), 'configActive');
                Core.addClass(Core.getById(act), 'configActive');
                break;
            case tvKey.KEY_RIGHT:
            case tvKey.KEY_DOWN:
                var act = Core.getByClass('.configActive').getAttribute('data-next');
                Core.removeClass(Core.getByClass('.configActive'), 'configActive');
                Core.addClass(Core.getById(act), 'configActive');
                break;
            case tvKey.KEY_RETURN:
                widgetAPI.blockNavigation(event);
                Configs.hide();
                break;
            case tvKey.KEY_ENTER:
                switch(Core.getByClass('.configActive').getAttribute('id')){
                    case 'connectionTypeDirect':
                        Core.removeClass(Core.getById("connectionTypeDirectIcon"), 'myRadioButtonNotSelected');
                        Core.addClass(Core.getById("connectionTypeDirectIcon"), 'myRadioButtonSelected');
                        Core.removeClass(Core.getById("connectionTypeProxyIcon"), 'myRadioButtonSelected');
                        Core.addClass(Core.getById("connectionTypeProxyIcon"), 'myRadioButtonNotSelected');
                        
                        ProjectInfo.useProxy = 'false';
                        break;
                    case 'connectionTypeProxy':
                        Core.removeClass(Core.getById("connectionTypeDirectIcon"), 'myRadioButtonSelected');
                        Core.addClass(Core.getById("connectionTypeDirectIcon"), 'myRadioButtonNotSelected');
                        Core.removeClass(Core.getById("connectionTypeProxyIcon"), 'myRadioButtonNotSelected');
                        Core.addClass(Core.getById("connectionTypeProxyIcon"), 'myRadioButtonSelected');
                        
                        ProjectInfo.useProxy = 'true';
                        break;
                    case 'connectionTypeProxyAddress':
                        Core.getById("configMulticastProxyAddressInput").value = ProjectInfo.proxyAddress;
                        Core.showElement(Core.getById("configMulticastProxyAddressInput"));
                        ProxyInput.init("configMulticastProxyAddressInput");
                        break;
                    case 'configButtonSubmit':
                        Configs.saveConfigs();
                        break;
                    case 'configButtonClose':
                        Configs.hide();
                        break;
                }
                break;
        }
    }
};